︠4b9595df-6da9-4af3-aa24-ee383aea9f80s︠
def b_div_by_3(n):
    if n%3==2:
        return (n//3)+1
    else:
        return n//3
︡1bc8a521-3421-4b54-91ee-b5d3738d53d6︡{"done":true}︡
︠da101db5-b4c5-4b61-9157-9a2ac67fc586s︠
def b_mod_3(n):
    if n%3==2:
        return -1
    else:
        return n%3
︡7912fe46-e5e4-4cd5-8b08-3d89ce993933︡{"done":true}︡
︠3efbb2ce-7e4e-4290-81b2-ef64fdd6d632︠
︡63dfde74-bb14-4f96-99b7-59092bf0a4b6︡
︠bfd1d76e-3537-450c-a225-b9d9870a4ad2s︠
def tern(n):
    if n==0:
        return [0]
    elif abs(n)==1:
        return [n]
    else:
        return [b_mod_3(n)]+tern(b_div_by_3(n))
︡b5060d05-0e42-4d17-a3e2-8dc2b3e60674︡{"done":true}︡
︠a814524e-41e0-4190-b1c1-d0dea5efd2das︠
def tern_powers(n):
    t=tern(n)
    l=len(t)
    return [[3^(k) for k in range(len(t))],t]
︡2dba3a51-79ae-4d63-9cac-4a6664d98100︡{"done":true}︡
︠db49f33c-552c-4b4d-9c40-550483a13c3as︠
tern_powers(17)
︡e1ffceea-b507-4549-aab1-bb765df0aca2︡{"stdout":"[[1, 3, 9, 27], [-1, 0, -1, 1]]\n"}︡{"done":true}︡
︠22229f13-7e26-400b-a148-297039fd087fs︠
from sage.plot.polygon import Polygon
︡f3f2401d-864a-44ca-aefa-652e86a9d54d︡{"done":true}︡
︠1a97f6ea-8383-4a44-a04e-ca6699746289s︠


︡e5fa5e54-e4a7-4bdb-8f6d-52e6000d1a36︡{"done":true}︡
︠28b0b7be-668a-481d-81f6-afae40c4201cs︠
def visual_tern(n):
    dat=tern_powers(n)
    exp=1/2
    w=2*abs(n)^exp
    pic=Graphics()
    nb=0
    pb=0
    nbase=[]
    pbase=[]
    for k in reversed(range(len(dat[0]))):
        if dat[1][k]>0:
            pbase=pbase+[dat[0][k]]
            s=dat[0][k]^exp.n()
            pic+=polygon([(w-s,pb),(w+s,pb),(w+s,pb+s),(w-s,pb+s)])
            pic+=text(str(dat[0][k]),(w,pb+s/2),color='yellow')
            pb+=s
        elif dat[1][k]<0:
            nbase=nbase+[dat[0][k]]
            s=dat[0][k]^exp.n()
            pic+=polygon([(-w+s,nb),(-w-s,nb),(-w-s,nb+s),(-w+s,nb+s)])
            pic+=text(str(dat[0][k]),(-w,nb+s/2),color='yellow')
            nb+=s
    if n>0:
        s=n^exp
        pic+=polygon([(-w+s,nb),(-w-s,nb),(-w-s,nb+s),(-w+s,nb+s)],color='black')
        pic+=text(str(n),(-w,nb+s/2),color='red')
    else:
        s=(-n)^exp
        pic+=polygon([(w+s,pb),(w-s,pb),(w-s,pb+s),(w+s,pb+s)],color='black')
        pic+=text(str(n),(w,pb+s/2),color='red')
    pic+=line([(-2*w,0),(2*w,0)],color='black')
    pic+=polygon([(0,0),(w/4,-w/4),(-w/4,-w/4)],color='red')
    pic+=text(str(n)+" = sum("+str(pbase)+")-sum("+str(nbase)+")",(0,-(abs(n)^exp)))
    pic.show(axes=False)
︡c9c02b10-9376-468b-9b53-2c4a3be6c1d1︡{"done":true}︡
︠194225e7-d773-4263-b45c-29fa43ebbbe3︠
︡92540fbf-10b0-4160-9af0-f7fd8154d6a1︡
︠5b626cba-a5af-44d5-a801-e15e3faa93d8s︠
visual_tern(178)
︡370611f8-5238-45e2-80a9-058b8e7aecb0︡{"file":{"filename":"/home/user/.sage/temp/project-f351622c-d261-4717-abee-4c0bfa210e88/240/tmp_yytiHP.svg","show":true,"text":null,"uuid":"9a6bff2a-5d0f-46a3-afff-975aca8e3b4d"},"once":false}︡{"done":true}︡
︠f7f7c020-a13a-44c0-81c4-4d2c9783d9e0︠

︡928268c1-7806-4f4b-aa86-9b311158b616︡
︠320410e1-8a3a-4f3e-a85f-7f4076953690︠
︡17fca7be-f4f8-45e7-b901-d54ef1d218ac︡
︠eac15da8-4206-4ecc-b56a-5759b3fbefcds︠
visual_tern(7)
︡d525b00a-8f1e-464f-b24f-12bac17bf9a1︡{"file":{"filename":"/home/user/.sage/temp/project-f351622c-d261-4717-abee-4c0bfa210e88/240/tmp_zR4rty.svg","show":true,"text":null,"uuid":"ddd6ec83-3346-4cb4-85b9-36b5a5b5592c"},"once":false}︡{"done":true}︡
︠57ca9030-a321-4433-a08e-edd979a9c976s︠
@interact
def _(n=(1..2000)):
    visual_tern(n)
︡52a18edc-be8a-4a6e-966d-d09aaf8bd411︡{"interact":{"controls":[{"animate":true,"control_type":"slider","default":0,"display_value":true,"label":"n","vals":["1","5","9","13","17","21","25","29","33","37","41","45","49","53","57","61","65","69","73","77","81","85","89","93","97","101","105","109","113","117","121","125","129","133","137","141","145","149","153","157","161","165","169","173","177","181","185","189","193","197","201","205","209","213","217","221","225","229","233","237","241","245","249","253","257","261","265","269","273","277","281","285","289","293","297","301","305","309","313","317","321","325","329","333","337","341","345","349","353","357","361","365","369","373","377","381","385","389","393","397","401","405","409","413","417","421","425","429","433","437","441","445","449","453","457","461","465","469","473","477","481","485","489","493","497","501","505","509","513","517","521","525","529","533","537","541","545","549","553","557","561","565","569","573","577","581","585","589","593","597","601","605","609","613","617","621","625","629","633","637","641","645","649","653","657","661","665","669","673","677","681","685","689","693","697","701","705","709","713","717","721","725","729","733","737","741","745","749","753","757","761","765","769","773","777","781","785","789","793","797","801","805","809","813","817","821","825","829","833","837","841","845","849","853","857","861","865","869","873","877","881","885","889","893","897","901","905","909","913","917","921","925","929","933","937","941","945","949","953","957","961","965","969","973","977","981","985","989","993","997","1001","1005","1009","1013","1017","1021","1025","1029","1033","1037","1041","1045","1049","1053","1057","1061","1065","1069","1073","1077","1081","1085","1089","1093","1097","1101","1105","1109","1113","1117","1121","1125","1129","1133","1137","1141","1145","1149","1153","1157","1161","1165","1169","1173","1177","1181","1185","1189","1193","1197","1201","1205","1209","1213","1217","1221","1225","1229","1233","1237","1241","1245","1249","1253","1257","1261","1265","1269","1273","1277","1281","1285","1289","1293","1297","1301","1305","1309","1313","1317","1321","1325","1329","1333","1337","1341","1345","1349","1353","1357","1361","1365","1369","1373","1377","1381","1385","1389","1393","1397","1401","1405","1409","1413","1417","1421","1425","1429","1433","1437","1441","1445","1449","1453","1457","1461","1465","1469","1473","1477","1481","1485","1489","1493","1497","1501","1505","1509","1513","1517","1521","1525","1529","1533","1537","1541","1545","1549","1553","1557","1561","1565","1569","1573","1577","1581","1585","1589","1593","1597","1601","1605","1609","1613","1617","1621","1625","1629","1633","1637","1641","1645","1649","1653","1657","1661","1665","1669","1673","1677","1681","1685","1689","1693","1697","1701","1705","1709","1713","1717","1721","1725","1729","1733","1737","1741","1745","1749","1753","1757","1761","1765","1769","1773","1777","1781","1785","1789","1793","1797","1801","1805","1809","1813","1817","1821","1825","1829","1833","1837","1841","1845","1849","1853","1857","1861","1865","1869","1873","1877","1881","1885","1889","1893","1897","1901","1905","1909","1913","1917","1921","1925","1929","1933","1937","1941","1945","1949","1953","1957","1961","1965","1969","1973","1977","1981","1985","1989","1993","1997"],"var":"n","width":null}],"flicker":false,"id":"0fe3a8ca-02e5-4c26-86c0-a48ac4cfaf2a","layout":[[["n",12,null]],[["",12,null]]],"style":"None"}}︡{"done":true}︡
︠20675d9e-1002-4266-ace4-40c098ca5ecds︠
for k in reversed(range(5)):
    print k
︡e879f3b0-53cd-46e9-a3be-206adc31a982︡{"stdout":"4\n3\n2\n1\n0\n"}︡{"done":true}︡
︠917113f3-3c68-4f25-98c5-11f93136922f︠
L=range(5)

︡cbe28b5e-7691-40d1-ba13-05a87af56b43︡{"stderr":"Error in lines 2-3\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1044, in execute\n    exec compile(block+'\\n', '', 'single', flags=compile_flags) in namespace, locals\n  File \"\", line 1, in <module>\nTypeError: 'NoneType' object is not iterable\n"}︡{"done":true}︡
︠18fa6f68-04d5-4b6d-8ab0-bb4bc10a730e︠









